<html>
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width,initial-scale=1.0">
<link rel="stylesheet" type="text/css" href="app.css">
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
<script src='https://kit.fontawesome.com/a076d05399.js'></script>
<script src="https://js.pusher.com/5.0/pusher.min.js"></script>
</head>
<body>
    <div class="top-header">
        <div class="header-title">LET'S CHAT</div>
    </div>
    <div class="chat-box">
        <div class="create-channel hover-link">
           <input type="text" id="input-channel" class="channel-input hover-input" placeholder="Create channel..." required/>
           <input type="submit" id="button" class="channel-button hover-button" value="Create Channel" onclick="sendChannelName()"/>
           <div id="display-name">
           </div>
        </div>
        <div class="message-box" id="page-refreshing">
            <div id="currentChannel">
            </div>
            <div id="displayMessage">
            </div>
            <div class="send-message-box">
                <div class="write-message" id="Message" contenteditable>
                    <input type="text" id="getMessage" placeholder="Write message..." required/>
                </div>
                <button type="submit" class="send-button" id="send-button" onclick="addNewMessages()"><i class="fa fa-paper-plane"></i> Send</button>
                </div>       
        </div>

<script>

// Enable pusher logging
Pusher.logToConsole = true;
var pusher = new Pusher('ae5d398e2ed6fc4ce44f', {
    cluster: 'ap2',
    forceTLS: true
});
var channel = pusher.subscribe('messages');
channel.bind('message-added', function(data)
    {
        getPusherMessage=data;
        console.log('new data', getPusherMessage.text);
        showUserMessages(getPusherMessage.channel_id,channelName.currentChannelName);
        window.alert("You got new message!");
    });

//send Channel name
displayChannel();
function sendChannelName()
{
    let channelName=document.getElementById("input-channel").value;
    fetch('http://localhost:5000/channels',{
        method:'post',
        body:JSON.stringify({
        name: channelName
        })}).then(()=>{
            displayChannel();
        })
}

//Getting Channel name from database
function displayChannel()
{
    document.getElementById("currentChannel").style.display = "none";
    let inputChannel = document.getElementById('input-channel');
    inputChannel.value = "";
    var promise = new Promise((resolve,reject)=>
    {
        var request=new XMLHttpRequest();
        request.open('GET','http://localhost:5000/channels/',true);
        request.onload=function()
        {
            if(this.status==200)
            {
                resolve(this.responseText);
            }
            else
            {
                reject(Error(this.statusText));
            }
        }
        request.onerror = function()
        {
            reject(Error("Error fetching data..."));
        }
         request.send();
    });
    promise.then((data) =>
    {
        var users=JSON.parse(data);
        var output='';
        var file=users.resources;
        for (let i in file )
        {
            output += 
                `<h3><a href="#" id="${file[i].id}" class="display" onclick="showUserMessages(${file[i].id},'${file[i].name}');">`+
                "#"+" "+file[i].name +
                `</a></h3>`;
        } 
        document.getElementById("display-name").innerHTML=output;
        
    });
   
}


//Check the id to get the message
channelId={} //append the id globally
channelName={}//append the channel name globally

//Show user messages
function showUserMessages(id,currentChannelName)
{  
    channelId.id=id;
    channelName.currentChannelName=currentChannelName;

    var promise = new Promise((get,error) =>
    {
        var msgRequest= new XMLHttpRequest();
        msgRequest.open('GET','http://127.0.0.1:5000/messages/?channel_id=' +id,true);
        msgRequest.onload=function()
        {
            if(this.status==200)
            {
                get(this.responseText)

            }
            else
            {
                error(Error(this.statusText));
            }

        }

        msgRequest.onerror = function()
        {
            reject(Error("Error fetching data..."));
        }
        msgRequest.send();

    });
    promise.then((data) =>
    {  
        var users=JSON.parse(data);
        var file=users.resources;
        var getMessage='';
        for(let ele in file)
        {   
            getMessage +=  '<h3 id="username-style"><div class="displayMessage">' +'<i class="fas fa-user"></i>'+ file[ele].username +'</br>'+'</h3>'+
            '<div class="userMessage">'+file[ele].text +'</div>'+'</div>';
        }
        document.getElementById("currentChannel").style.display = "block";
        document.getElementById("currentChannel").innerHTML=currentChannelName;
        document.getElementById("displayMessage").innerHTML=getMessage;   
    });
}


//Adding the message in particular channel

function addNewMessages()
{   
    let getStoredUsername=document.getElementById("displayMessage").innerHTML= sessionStorage.getItem("username");
    let addMessage = document.getElementById("getMessage").value;
    fetch('http://localhost:5000/messages?channel_id=' +channelId.id,{ //Here,using the global id
        method:'post',
        body:JSON.stringify({
        text: addMessage,
        username:getStoredUsername,
        channel_id:channelId.id
        })}).then(()=>{
            showUserMessages(channelId.id,channelName.currentChannelName);
            let getMessage=document.getElementById('getMessage');
            getMessage.value="";
            })
            fetch('http://localhost:5000/broadcast',{
            method:'post',
            body:JSON.stringify({
            text: addMessage,
            username:getStoredUsername,
            channel_id:channelId.id
             })})
}


</script>
</body>
</html>

